/***************************************************************************
                          cataloghandler.h  -  description
                             -------------------
    begin                : Thu Mar 20 2003
    copyright            : (C) 2003 by Stefano Salvador
    email                : salva_ste@tin.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CATALOGHANDLER_H
#define CATALOGHANDLER_H

#include "catalogentry.h"
#include "categoryhandler.h"

class QDir;
class KProgressDialog;
class CatTreeItem;

/**This class creates and maintains the catalogs
  *@author Stefano Salvador
  */

class CatalogHandler
{
public:

  /** Public constructor */
  CatalogHandler();

  /** Public destructor */
  ~CatalogHandler();

  /** Create a new catalogue a visualize it as a parent in ListView */
  CatTreeItem* newCatalog( QString dir, QString n, QString des, QDate* dat, QStringList* l, bool propagate = true );

  /** Create a new catalogue a visualize it as a parent in ListView */
  CatTreeItem* newCatalog( QString n, QString des, QDate* dat, QStringList* l );

  /** Add an entry to the tree of an existing catalogue */
  CatTreeItem* addEntry( CatTreeItem* parent, QString p, int s, QString des, QDate* dat, QStringList* l, int entry_type );

  /** Removes the catalogue from the document */
  void removeCatalog( CatTreeItem * );
  /** No descriptions */
  void clear();
  /** No descriptions */
  void removeCategory( QString );

  QValueList<CatTreeItem *> logList;

private: // Private methods
  /** Reads the directory passed as argument and gets all needed infos */
  bool scanDir( QDir dir, CatTreeItem *ce );

  /** Stores the list of categories */
  QStringList *catl;

  /** No descriptions */
  void removeCategory( CatTreeItem *, QString );
  /** Quickly scan mount point counting total number of files */
  void totalEntries( QDir dir );

  int totEntries;

  KProgressDialog *prgDlg;
};

#endif
