/***************************************************************************
                          categoryview.h  -  description
                             -------------------
    begin                : Fri Mar 28 2003
    copyright            : (C) 2003 by Stefano Salvador
    email                : salva_ste@tin.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CATEGORYVIEW_H
#define CATEGORYVIEW_H

#include <qwidget.h>

class CategoryHandler;
class KListView;
class QVBoxLayout;
class QLineEdit;
class QFrame;
class QLabel;
class Category;
class QPushButton;
class QListViewItem;

/**This widget manages the GUI for categories
  *@author Stefano Salvador
  */

class CategoryView : public QWidget  {
   Q_OBJECT
public: 
  CategoryView( QWidget *parent=0, const char *name=0, CategoryHandler *ch = 0 );
  ~CategoryView();
  /** Initialize the mid view */
  void initMid();

private:
  CategoryHandler *chandler;
  KListView *lv;
  QVBoxLayout *vbox;
  QLineEdit *ename;
  QLineEdit *edesc;
  QPushButton *edit;
  QFrame *mid;
  Category *ca;
  QLabel *lcapt;
  QPushButton *add;
public slots: // Public slots
  /** Used to delete a category */
  void slotDelete();
  /** Used to initialize the view */
  void slotInit();
  /** Used to add an item to category */
  void slotAdd( bool on );
  /** Used to modify a category */
  void slotEdit( bool on );
  /** No descriptions */
  void slotDone();
  /** No descriptions */
  void slotSelected( QListViewItem * );
signals: // Signals
  /** emitted when a category is removed */
  void categoryDeleted( QString );
  /** emitted to notify changed to the list of categories */
  void categoryChanged();

};

#endif
