/***************************************************************************
                          katalogview.cpp  -  description
                             -------------------
    begin                : Tue Mar 18 14:57:05 CET 2003
    copyright            : (C) 2003 by Stefano Salvador
    email                : salva_ste@tin.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

// include files for Qt
#include <qprinter.h>
#include <qpainter.h>
#include <qsplitter.h>
#include <qdatetime.h>
#include <qtextbrowser.h>
#include <qvbox.h>
#include <qhbox.h>

// include files for KDE
#include <kjanuswidget.h>
#include <klocale.h>
#include <klistview.h>
#include <kmessagebox.h>
#include <kiconloader.h>
#include <kstandarddirs.h>

// application specific includes
#include "katalogview.h"
#include "katalogdoc.h"
#include "katalog.h"
#include "cataloghandler.h"
#include "catalogentry.h"
#include "catalogview.h"
#include "categoryhandler.h"
#include "categoryview.h"
#include "searchview.h"

KatalogView::KatalogView( KatalogDoc *pDoc, QWidget *parent, const char *name) :
KJanusWidget(parent, name, KJanusWidget::IconList)
{
  KIconLoader *icon = KGlobal::iconLoader();
  QVBox *fm;
  doc = pDoc;

  // Page 1
  QHBox *f = addHBoxPage( QString(i18n("Viewer")), i18n("Catalogs"), icon->loadIcon( "contents", KIcon::Panel ) );
  logView = new CatalogView( f, "", doc );

  // Page 2
  fm = addVBoxPage( QString(i18n("Search")), i18n("Search an entry in Catalogues"), icon->loadIcon( "filefind", KIcon::Panel ) );
  SearchView *seaView =new SearchView( fm, "", doc );

  // Page 3
  fm = addVBoxPage( QString(i18n("Categories")), i18n("Catalories handler"), icon->loadIcon( "configure", KIcon::Panel ) );
  CategoryView *oryView =new CategoryView( fm, "", doc->oryHand );

  // Page 4
  fm = addVBoxPage( QString(i18n("Documentation")), i18n("Documentation"), icon->loadIcon( "help", KIcon::Panel ) );
  QTextBrowser *w = new QTextBrowser( fm );
  QString str = KGlobal::dirs()->findResource( "html", "en/katalog/index.html" );
  w->setSource( str );

  showPage( 3 );

  connect( doc, SIGNAL( docChanged() ), logView, SLOT( RefreshLView() ) );
  connect( doc, SIGNAL( docChanged() ), oryView, SLOT( slotInit() ) );
  connect( logView, SIGNAL( catalogChanged() ), seaView, SLOT( initView() ) );
  connect( oryView, SIGNAL( categoryChanged() ), seaView, SLOT( initView() ) );
  connect( oryView, SIGNAL( categoryDeleted( QString ) ), this, SLOT( removeCategory( QString ) ) );
}

KatalogView::~KatalogView()
{
}

KatalogDoc *KatalogView::getDocument() const
{
  KatalogApp *theApp=(KatalogApp *) parentWidget();

  return theApp->getDocument();
}

void KatalogView::print(QPrinter *pPrinter)
{
  QPainter printpainter;
  printpainter.begin(pPrinter);
	
  // TODO: add your printing code here

  printpainter.end();
}

void KatalogView::resizeEvent( QResizeEvent *)
{
/*  QSize a = this->size();
  view->resize();
  cview->resize(a);*/
}

/** No descriptions */
void KatalogView::removeCategory( QString str )
{
  doc->logHand->removeCategory( str );
  logView->RefreshRView();
}
