/***************************************************************************
                          midview.h  -  description
                             -------------------
    begin                : Fri Apr 11 2003
    copyright            : (C) 2003 by Stefano Salvador
    email                : salva_ste@tin.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MIDVIEW_H
#define MIDVIEW_H

#include <qframe.h>

// Some declaration to speed up compilation
class QListViewItem;
class QPushButton;
class QSplitter;
class QLineEdit;
class QCheckBox;
class QListBox;
class QFrame;
class QLabel;

/**Smart Dialog used to edit entries
  *@author Stefano Salvador
  */

class MidView : public QFrame  {
   Q_OBJECT
public:
  MidView( QWidget * parent );
  ~MidView();

  /** Returns the choosed categories */
  QStringList *CatList();

  /** sets the categories in the listbox */
  void setCatList( QStringList *, QStringList * );

  /** Returns the name of the entry or the catalogue */
  QString Name();

  /** Set the name of the entry or the catalogue */
  void setName( QString );

  /** Returns the name of the entry or the catalogue */
  QString Mount();

  /** Set the name of the entry or the catalogue */
  void setMount( QString );

  /** Returns the description of the entry or the catalogue */
  QString Description();

  /** Set the description of the entry or the catalogue */
  void setDescription( QString );

  /** Show/Hide the mount point dialog */
  void MountEnabled( bool );

  /** Set the caption of the dialog */
  void setCaption( QString );

  /** Return the state of the check box */
  bool isChecked();

  /** The Dir Dialog Button */
  QPushButton *lchoose;

  /** The Done Button */
  QPushButton *ldone;

public slots: // Public slots
  /** Used to choose the mount point */
  void slotOpen();

private:
  /** Name of the entry */
  QLineEdit *ename;

  /** Description of the entry */
  QLineEdit *edesc;

  /** Mount Point of the catalog (if needed) */
  QLineEdit *emount;

  /** List of Categories */
  QListBox *eCategory;

  /** Propagation check button */
  QCheckBox *check;

  /** Caption of the dialog */
  QLabel *lcapt;

  /** The label of the mount point */
  QLabel *lmount;
};

#endif
